<template>
    <div>
        <el-card class="el-card">
            <el-form :inline="true" :model="filterQuery" class="query-form" size="mini">
                <el-form-item class="query-form-item">
                    <el-input
                        v-model="filterQuery.code"
                        placeholder="产品编码/商品条码/医保编码" clearable
                        @keyup.enter.native="keyupErp_submit($event)"
                    ></el-input>
                </el-form-item>
                <el-form-item class="query-form-item">
                    <el-input
                        v-model="filterQuery.name" clearable
                        placeholder="产品名称"
                    ></el-input>
                </el-form-item>
                <el-form-item class="query-form-item">
                    <el-input
                        v-model="filterQuery.spec" clearable
                        placeholder="规格型号"
                    ></el-input>
                </el-form-item>
                <el-form-item class="query-form-item">
                    <el-input
                        v-model="filterQuery.registerNo" clearable
                        placeholder="注册/备案凭证"
                    ></el-input>
                </el-form-item>
                <el-form-item class="query-form-item">
                    <el-select v-model="filterQuery.checkStatus" placeholder="审核状态">
                        <el-option label="全部" value=""></el-option>
                        <el-option label="已审核" value="2"></el-option>
                        <el-option label="未审核" value="1"></el-option>
                        <el-option label="未通过" value="3"></el-option>
                    </el-select>
                </el-form-item>
                <el-form-item class="query-form-item">
                    <el-select v-model="filterQuery.thirdSys" placeholder="请选择第三方系统" @change="thirdSysChange">
                        <el-option
                            v-for="item in thirdSys"
                            :key="item.value"
                            :label="item.thirdName"
                            :value="item.thirdId">
                            <span style="float: left">{{ item.thirdName }}</span>
                            <span style="float: right; color: #8492a6; font-size: 13px">{{ item.thirdId }}</span>
                        </el-option>
                    </el-select>
                </el-form-item>
                <el-form-item>
                    <el-button-group style="display:flex;">
                        <el-button type="primary" icon="el-icon-refresh" @click="onReset"></el-button>
                        <el-button type="primary" icon="search" @click="search">查询</el-button>
                        <el-button type="primary" @click="addProductVisible=true">新增</el-button>
                    </el-button-group>
                </el-form-item>
            </el-form>
            <el-table v-loading="loading" :data="list" style="width: 100%">
                <el-table-column label="序号" type="index" width="80"></el-table-column>
                <el-table-column label="产品编码" prop="code"></el-table-column>
                <el-table-column label="产品名称" prop="name" show-overflow-tooltip></el-table-column>
                <el-table-column label="规格型号" prop="spec" show-overflow-tooltip></el-table-column>
                <el-table-column label="计量单位" prop="measname" show-overflow-tooltip></el-table-column>
                <el-table-column label="注册/备案凭证" prop="registerNo" show-overflow-tooltip></el-table-column>
                <el-table-column label="生产厂家" prop="manufactory" show-overflow-tooltip></el-table-column>

                <el-table-column label="审核状态" prop="checkStatus" show-overflow-tooltip>
                    <template slot-scope="scope">
                        <span>{{ checkMap[scope.row.checkStatus] }}</span>
                    </template>
                </el-table-column>
                <el-table-column label="操作" fixed="right">
                    <template slot-scope="scope">
                        <el-button type="text" size="small" @click.native.stop="detailDialog(scope.row)"
                        >详情
                        </el-button>
                        <el-button type="text" size="small" @click.native.stop="deleteDialog(scope.row)"
                                   v-if="thirdSysDetail.fromType!=0"
                        >删除
                        </el-button>

                    </template>
                </el-table-column>
            </el-table>
            <el-pagination
                :page-size="filterQuery.limit"
                @current-change="handleCurrentChange"
                layout="prev, pager, next"
                :total="total"
                :current-page="filterQuery.page"
            ></el-pagination>
        </el-card>
        <el-dialog
            :close-on-click-modal="false"
            :close-on-press-escape="false"
            title="产品信息详情"
            :visible.sync="thrProductsDetailVisible"
            width="85%"
            v-if="thrProductsDetailVisible"
        >
            <thrProductsDetail
                :data="thisData"
            ></thrProductsDetail>
        </el-dialog>
        <el-dialog
            :close-on-click-modal="false"
            :close-on-press-escape="false"
            title="审核"
            :visible.sync="checkVisible"
            width="45%"
            v-if="checkVisible">
            <el-button @click="checkVisible = false">取消</el-button>
            <el-button type="primary" @click="checkPass(2)">通过</el-button>
            <el-button type="primary" @click="checkPass(3)">不通过</el-button>
        </el-dialog>
        <el-dialog
            :close-on-click-modal="false"
            :close-on-press-escape="false"
            title="手动添加第三方产品信息关联"
            :visible.sync="addProductVisible"
            width="85%"
            v-if="addProductVisible"
            @close="closeAddDialog"
        >

            <ThrProductsAdd
                :newType="newType"
                :closeAddDialog="closeAddDialog"></ThrProductsAdd>
        </el-dialog>
    </div>
</template>
<script>
import {getThrProducts, delThrProducts, updateProduct} from "../../api/thrsys/thrProductsAdd";
import {getBasicThirdSys, filterDetailByKey} from "../../api/basic/basicThirdSys";
import {selectIp} from "../../api/param/systemParamConfig";
import thrProductsDetail from "./ThrProductsDetail";
import ThrProductsAdd from "@/views/thrsys/ThrProductsAdd";

export default {

    data() {
        return {
            filterQuery: {
                code: null,
                name: "",
                spec: null,
                registerNo: null,
                manufactory: null,
                thirdSys: "",
                page: 1,
                limit: 20,
            },
            total: 0,
            thirdSys: [],
            thirdSysDetail: null,
            list: [],
            uploadFileUrl: null,
            fileList: [],
            uploadData: {
                thirdSys: "thirdId",
            },
            addProductVisible: false,
            checkVisible: false,
            newType: 2,
            thrProductsDetailVisible: false,
            thisData: null,
            loading: false,
            checkMap: {
                1: "未审核",
                2: "已审核",
                3: "未通过",
            },
            curRow: null,
        };
    },

    methods: {
        onReset() {
            this.$router.push({
                path: "",
            });
            this.filterQuery = {
                code: null,
                spec: null,
                registerNo: null,
                manufactory: null,
                name: "",
                thirdSys: null,
                page: 1,
                limit: 20,
            };
            this.getList();
        },
        search() {
            this.filterQuery.page = 1;
            this.getList();
        },
        checDialog(row) {
            this.checkVisible = true;
            this.curRow = row;
        },
        getList() {
            if (this.filterQuery.thirdSys == null) {
                this.$message.warning("请先选择第三方系统！")
                return;
            }
            this.loading = true;
            getThrProducts(this.filterQuery)
                .then((response) => {
                    // this.loading = false;
                    if (response.code == 20000) {
                        this.list = response.data.list || [];
                        this.total = response.data.total || 0;
                    } else {
                        this.$message.error(response.message);
                    }
                    this.loading = false;
                })
                .catch(() => {
                    this.loading = false;
                    this.list = [];
                    this.total = 0;
                });
        },
        deleteDialog(row) {
            this.$confirm("此操作将永久删除该产品信息, 是否继续?", "提示", {
                confirmButtonText: "确定",
                cancelButtonText: "取消",
                type: "warning",
            })
                .then(() => {
                    let dQuery = {
                        id: row.id,
                    };
                    delThrProducts(dQuery)
                        .then((response) => {
                            this.loading = false;
                            if (response.code == 20000) {
                                this.$message.success("删除成功");
                                this.getList();
                            } else {
                                this.$message.success(response.message);
                            }
                        })
                        .catch(() => {
                            this.loading = false;
                        });

                })
                .catch(() => {
                });
        },

        detailDialog(row) {
            this.thisData = row;
            this.thrProductsDetailVisible = true;
        },
        getBasicThirdSys() {
            let query = {
                enabled: true,
            };
            getBasicThirdSys(query)
                .then((response) => {
                    this.thirdSys = response.data.list || [];
                    this.filterQuery.thirdSys = this.thirdSys[0].thirdId;
                    this.uploadData.thirdSys = this.filterQuery.thirdSys;
                    this.getThirdSysDetail();
                    this.selectSysParam();
                    this.getList();
                })
                .catch(() => {
                    this.loading = false;
                    this.list = [];
                });
        },
        getThirdSysDetail() {
            let query = {
                thirdSysFk: this.filterQuery.thirdSys,
                key: "piQueryUrl",
            };
            filterDetailByKey(query)
                .then((response) => {
                    this.thirdSysDetail = response.data;
                })
                .catch(() => {
                    this.loading = false;
                    this.list = [];
                });

        },
        handleCurrentChange(val) {
            this.filterQuery.page = val;
            this.getList();
        },
        handleChange(response, files, fileList) {
            console.log(response);
            if (response.code != 20000) {
                this.$message.error(response.message);
            } else {
                console.log(files[0] + "\n" + this.fileList[0] + "\n" + fileList[0]);
                this.$message.success("文件上传成功,请稍后刷新查看！");
            }
        },
        selectSysParam() {
            let query = {
                key: "thirdIpUrl",
                thirdSysFk: this.filterQuery.thirdSys
            };
            selectIp(query).then((response) => {
                if (response.code == 20000) {
                    this.uploadFileUrl = response.data.thridUrl + "/udiwms/erp/pi/upload";
                }
            });
        },
        thirdSysChange() {
            this.uploadData.thirdSys = this.filterQuery.thirdSys;
            this.getThirdSysDetail();
        },
        closeAddDialog(val) {
            if (val) {
                this.getList();
            }
            this.addProductVisible = false;
        },
        checkPass(val) {
            let query = {
                id: this.curRow.id,
                checkStatus: val
            }
            updateProduct(query).then((res) => {
                if (res.code == 20000) {
                    this.getList();
                    this.checkVisible = false;
                } else {
                    this.$message.error(error.message);
                }
            }).catch((error) => {
                this.$message.error(error.message);
            })
        },
    },
    components: {
        thrProductsDetail, ThrProductsAdd
    },
    mounted() {
    },
    created() {
        this.getBasicThirdSys();
    },
};
</script>
